
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h> 
#include "scansubs.h"

/* 
Copyright 1991, 1996 Computational Logic Inc.

This code was originally written by Miren Carranza circa 1992.  I have
had to fix a number of bugs.  Some only showed up when there was a
clash in the smybol table.

MKSmith, Apr 15 1996 */

char *replacechar(char *s, char old, char new)
 { char *p = s; 
   for ( ; *p; p++ ) { if (*p==old) *p=new; }; 
   return s;
 };

PSTRING substring(s,i,j) const PSTRING s; int i; int j; 
/* 0 based */
{ PSTRING x = (PSTRING) malloc (j-i+1);
  int max = strlen(s);
  if (j >= max) j = max;
  if (i < 0) i = 0;
  strncpy(x,s+i,j-i+1);                             
  *(x+j-i+1) = '\0';
  return x; }; 

PSTRING raise(s1) PSTRING s1; 
{ PSTRING s2;
  int len = strlen(s1);
  int i;
  s2=strdup(s1);
  for ( i = 0 ; i<len; i++ ) { if (s2[i] >= 'a' && s2[i] <= 'z') s2[i]=s2[i]-32; }; 
  return s2; };

int string_eq(s1,s2) PSTRING s1, s2; 
{ return string_equal(raise(s1),raise(s2)); }; 

PSYMBOLS symlook(s,ptab,tsize) char *s; int tsize; SYMBOLS ptab[tsize]; 

/* Symlook returns a pointer to the object containing s */
/* this can be a pointer to the object list where the collisions are */
/* or a pointer to the symbol table */

{PSYMBOLS p;
 int si;
 int i;
 s = replacechar(s,'%',':');  /* PACKAGE HACK: We replace all occurences of % by : . */
 i = hash(s,tsize);

 /* printf("We are in symlook storing %s (hash = %d)\n",s,i); debug */

 if (!(ptab[i].id)) /*empty?*/
   { ptab[i].id = s;
     ptab[i].next = NULL;
     return &ptab[i];
   }
 else if (string_equal(ptab[i].id, s)) /* is it there? */
   { /* printf("Ptab[i].id is there\n"); debug */
     return &ptab[i]; }
 else if (ptab[i].next == NULL)
   { /* printf(" Ptab[i].id is %s.  NEW .next.\n", ptab[i].id);  debug */
     p = (PSYMBOLS) malloc (sizeof(struct symbols)); /* malloc (sizeof (SYMBOLS)); */
     p->id = strdup(s);
     p->next = NULL;
     ptab[i].next = p;
     return p; }
 else
   { /* printf(" Ptab[i].id is %s.  Searching .next.\n", ptab[i].id); debug */
     return seqsearch(ptab[i].next, s, ptab); };
     /* there is a name already which may be my key or a collision */
     /* we need to do sequential search in object list */
     /* if not there we place it in the object list*/
};
   
PSYMBOLS seqsearch(p,s)           /* on entry p is nonNULL */
  PSYMBOLS p;
  char *s;
{ 
  PSYMBOLS q;
  while ( p != NULL)
   { if (string_equal(p->id, s))       /* strcmp returns 0 if a==b */
       { /* printf(" Found p->id = %s", p->id); debug */
         return p; }
     /* (next == NULL)... add the identifier at end of collision list*/
     else if (p->next == NULL)
       { /* printf(" p->id = %s, p->next = NULL.  NEW p->next.\n", p->id);  debug */
         q = (PSYMBOLS) malloc (sizeof(struct symbols));
	 q->id = strdup(s); 
	 q->next = NULL;
	 p->next = q;
	 return q; }
     else
       { /* printf(" p->id = %s, p->next = %d.\n", p->id, p->next); debug */
         p = p->next; }}
};      

int hash(s,tsize) char *s; int tsize;
{
 int slen = strlen(s);
 return (101 * s[0] + 103 * s[slen - 1] + 107 * slen) % tsize;
};

/* AVOID STRCPY.  Or know how to use it.

main()
 { PSTRING s1 = "TESTING";
   PSTRING s2 = "01234567890123456789012345678901234567890";
   PSTRING s3 = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";

   printf("\nTEST");
   printf("\ns1 = %s, strlen = %d", s1, strlen(s1));
   printf("\ns2 = %s, strlen = %d", s2, strlen(s2));
   printf("\ns3 = %s, strlen = %d", s3, strlen(s3));
   printf("\nsubstring(s1, 3, 5) = %s", substring(s1,3, 5));
   printf("\nsubstring(s2, 17, 26) = %s", substring(s2,17,26));
   printf("\nsubstring(s3, 2, 26) = %s", substring(s3,2, 26));
   printf("\nsubstring(s1, -3, 30) = %s", substring(s1,-3,30));
   printf("\n");

 };

*/
