
#ifndef SEMSTRUCTS
#define SEMSTRUCTS

enum cartype {tlist=0, tstring=1, tsym=2};

typedef enum cartype CARTYPE;

int fail_flag;

char *remove_tag;

typedef struct cell CELL;
typedef struct cell *PCELL;

union ctype 
{ PSTRING atom;
  PSYMBOLS psymbols;
  PCELL pcell;
};

typedef union ctype CTYPE;

struct cell
{ CARTYPE caflg;
  CTYPE pcar;
  PCELL pcdr;
};

int symbolp_car (PCELL l);
int stringp_car (PCELL l);
int consp_car (PCELL l);

PCELL lcar(PCELL l);
PSTRING strcar(PCELL l);
PSYMBOLS symcar(PCELL l);

PCELL cdr(PCELL x);

PCELL cons(PCELL x, PCELL y);
PCELL cons_terminal(PSTRING x, PCELL y);
PCELL cons_symbol(PSYMBOLS x, PCELL y);

PCELL list1(PCELL x);

PCELL append(PCELL x, PCELL y);

int removep(PCELL p);

void topwritetree(PCELL p);
void writetree(PCELL p);
void writenodes(PCELL p);

void freetree (PCELL p);
void freenodes (PCELL p);

void ptree (PCELL p) ;
void pnodes (PCELL p);

#endif SEMSTRUCTS
