
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h> 
#include "scansubs.h"
#include "semsubs.h"
#include "types.h"

PSTRING our_strcat(s1,s2) PSTRING s1; PSTRING s2;
{ PSTRING temp = (PSTRING) malloc (strlen(s1) + strlen(s2) + 1);
  strcpy(temp,s1);
  return strcat(temp, s2); };

int stringequal (x,y) char *x; char *y; {
  return !strcasecmp(x,y) ; };

PCELL make_name(x) PSTRING x;
{ return cons_terminal(remove_tag, cons_terminal(x, NULL)); };

PCELL replace(old, new, form) PCELL old; PCELL new; PCELL form;
 { PSYMBOLS aux;
   PSTRING s;

   if (old == NULL)  { printf("\nOld === NULL!!!"); }
   if (new == NULL)  { printf("\nNew === NULL!!!"); }

   if (form == NULL)         return form;
   if (forms_equal(old,form)) return new;
   if (symbolp_car(form)) return cons_symbol(symcar(form),replace(old,new,cdr(form)));
   if (stringp_car(form)) return cons_terminal(strcar(form),replace(old,new,cdr(form)));
   /* car is list. */
   if ( forms_equal(old,lcar(form)) ) return cons(new,replace(old,new,cdr(form)));
   return cons(replace(old,new,lcar(form)),replace(old,new,cdr(form)));
 };

int forms_equal(a,b) PCELL a; PCELL b;
{ if (a == NULL) { if (b == NULL) return 1; return 0; };
  if (b == NULL) { return 0; };
  if (cars_equal(a,b)) return forms_equal(cdr(a),cdr(b));
  return 0; };

int cars_equal(a,b) PCELL a; PCELL b;
{ if (symbolp_car(a))
  { if (symbolp_car(b))
    { if (!strcmp(a->pcar.psymbols->id,b->pcar.psymbols->id))
      return 1;
    return 0; }
  else return 0;};
  if (stringp_car(a))
    { if (stringp_car(b))
      { if (!strcmp(a->pcar.atom,b->pcar.atom))
	return 1;
      return 0; }
    else return 0;};
  if (consp_car(a))
    { if (consp_car(b))
      { if (cars_equal(a,b)) 
	return forms_equal(cdr(a),cdr(b));
      return 0; }; };
  return 0;};


/* main()
 { PCELL x = cons_terminal(remove_tag, cons_symbol("A", NULL));
   if (x != NULL) printf("X ne z\n");
   if (consp_car(x)) printf("consp_car(X)\n");
   if (x->caflg == tstring) printf("X->caflg == tstring\n");
   printf("X->pcar.atom == %s\n", x->pcar.atom);
   if (string_equal(x->pcar.atom,remove_tag)) printf("match\n"); else printf("nomatch\n");
 }								     

main()
 { PCELL x = cons_terminal(remove_tag, cons_symbol("A", NULL));
   ptree(x);
   printf("\n");

   types_to_pred("INTEGER", list1(x));
 }								     

main()
 { PSYMBOLS w;
   PCELL x;
   PCELL y;
   w = symlook( strdup("foobar"), symtab, NSYMS);
   printf(w->id);
   x = cons_symbol(w, NULL);
   printf("\ntok x\n");
   ptree(x);
   x = cons_terminal("B", x);
   y = list1(cons_terminal("ID",cons_terminal ("A", cons_terminal("NIL",NULL))));
   printf("\nx\n");
   ptree(x);
   printf("\ny\n");
   ptree(y);
   printf("\ny @ y\n");
   ptree(append(x,y));
 }

main()
 { PSYMBOLS f;
   PSYMBOLS a;
   PSYMBOLS b;
   PCELL f2;
   PCELL x;
   PCELL y;
   PCELL m;
   f = symlook( strdup("foo"), symtab, NSYMS);
   a = symlook( strdup("a"), symtab, NSYMS);
   b = symlook( strdup("b"), symtab, NSYMS);
   f2 = cons_terminal("--remove--", cons_symbol(f, NULL));
   x = cons_terminal("--remove--", cons_symbol(a, NULL));
   y = cons_terminal("--remove--", cons_symbol(b, NULL));
   m = cons(f2, cons(x, cons(y, NULL)));
   printf("\nm\n");
   ptree(m);
   printf("\nreplace_args(x,y,m)\n");
   ptree(replace_args(cons(x,cons(y,NULL)),m));
   printf("\nAnd now, with strings\n");
   f2 = cons_terminal("--remove--", cons_terminal("f", NULL));
   x = cons_terminal("--remove--", cons_terminal("a", NULL));
   y = cons_terminal("--remove--", cons_terminal("b", NULL));
   m = cons(f2, cons(x, cons(y, NULL)));
   printf("\nm\n");
   ptree(m);
   printf("\nreplace_args(x,y,m)\n");
   ptree(replace_args(cons(x,cons(y,NULL)),m));
 }

main()
 { PSTRING s = "TESTING";
   printf("\n%s", substring(s,0,4));
   printf("\n%s", substring(s,1,4));
   printf("\n%s", substring(s,3,4));
   printf("\n%s", make_constant_suffix("*abcd*","-foo"));
 }								     

*/


